## rockboxutility 1.4.0

=== tools/Makefile ===
#             __________               __   ___.
#   Open      \______   \ ____   ____ |  | _\_ |__   _______  ___
#   Source     |       _//  _ \_/ ___\|  |/ /| __ \ /  _ \  \/  /
#   Jukebox    |    |   (  <_> )  \___|    < | \_\ (  <_> > <  <
#   Firmware   |____|_  /\____/ \___  >__|_ \|___  /\____/__/\_ \
#                     \/            \/     \/    \/            \/
#
CFLAGS := -O -g -W -Wall -Wshadow -pedantic
LDFLAGS := -g

.PHONY: rbspeexenc uclpack

CLEANALL := scramble descramble iriver sh2d bmp2rb rdf2binary convbdf \
    generate_rocklatin mkboot ipod_fw codepages uclpack mi4 gigabeat lngdump \
    telechips gigabeats creative hmac-sha1 rbspeexenc mkzenboot mk500boot convttf

all: scramble descramble sh2d rdf2binary mkboot mkzenboot convbdf codepages \
	uclpack rbspeexenc voicefont mk500boot

scramble: scramble.o iriver.o mi4.o gigabeat.o gigabeats.o telechips.o \
	iaudio_bl_flash.o creative.o hmac-sha1.o rkw.o
descramble: descramble.o iriver.o gigabeat.o
scramble.o: scramble.c iriver.h mi4.h gigabeat.h telechips.h iaudio_bl_flash.h \
	creative.h rkw.h

descramble.o: descramble.c iriver.h gigabeat.h
creative.o: creative.c creative.h
hmac-sha1.o: hmac-sha1.c hmac-sha1.h
iriver.o: iriver.c iriver.h
gigabeat.o: gigabeat.c gigabeat.h
gigabeats.o: gigabeats.c gigabeats.h
mi4.o: mi4.c mi4.h
telechips.o: telechips.c telechips.h
rkw.o: rkw.c rkw.h
iaudio_bl_flash.o: iaudio_bl_flash.c iaudio_bl_flash.h
iaudio_bl_flash.c iaudio_bl_flash.h: iaudio_bl_flash.bmp bmp2rb
	$(SILENT)./bmp2rb -f 7 -h . $< >iaudio_bl_flash.c

sh2d: sh2d.c

bmp2rb:	bmp2rb.c
	$(SILENT)$(CC) -DAPPLICATION_NAME=\"$@\" $(CFLAGS) $+ -o $@

rdf2binary:	rdf2binary.c
	$(SILENT)$(CC) $(CFLAGS) $+ -o $@

mkboot:	mkboot.c
	$(SILENT)$(CC) $(CFLAGS) $+ -o $@

mk500boot: mk500boot.c mr500.c
	$(SILENT)$(CC) $(CFLAGS) $+ -o $@

mkzenboot.o: mkzenboot.c
	$(SILENT)$(CC) $(CFLAGS) -std=c99 -DSTANDALONE -c -o $@ $+

mkzenboot: mkzenboot.o hmac-sha1.o
	$(SILENT)$(CC) $(LDFLAGS) $+ -lz -o $@

mkzenboot.exe: mkzenboot.o hmac-sha1.o
	$(SILENT)$(CC) $(LDFLAGS) -lz $+ C:\MingW\lib\libz.a -o $@

lngdump: lngdump.c
	$(SILENT)$(CC) $(CFLAGS) $+ -o $@

ipod_fw:	ipod_fw.c
	$(SILENT)$(CC) $(CFLAGS) $+ -o $@

checkwps: checkwps.c ../apps/gui/wps_parser.c ../apps/gui/wps_debug.c \
	../firmware/common/ctype.c ../apps/misc.c ../apps/recorder/bmp.c
	$(SILENT)$(CC) $(CFLAGS) -I ../apps/gui -I../firmware/export \
	    -D__PCTOOL__ -DDEBUG -DROCKBOX_HAS_LOGF -DIPOD_COLOR \
	    -D ROCKBOX_DIR_LEN -D WPS_DIR=\".\" -I../apps \
	    -I../firmware/target/arm/ipod -I../firmware/include $+ -o $@

convbdf: convbdf.c
	$(SILENT)$(CC) $(CFLAGS) $+ -o $@

codepages: codepages.c codepage_tables.c
	$(SILENT)$(CC) $(CFLAGS) $+ -o $@

player_unifont: player_unifont.c ../firmware/drivers/lcd-charset-player.c
	$(SILENT)$(CC) -DARCHOS_PLAYER -D__PCTOOL__ -I../firmware/export $+ \
	    -o $@

uclpack:
	$(SILENT)$(MAKE) -C ucl

rbspeexenc:
	$(SILENT)$(MAKE) -C rbspeex

wavtrim: wavtrim.c
	$(SILENT)$(CC) $(CFLAGS) $+ -o $@

voicefont: voicefont.c
	$(SILENT)$(CC) $(CFLAGS) $+ -o $@

usb_benchmark: usb_benchmark.c
	$(SILENT)$(CC) $(CFLAGS) $+ -lusb -o $@

convttf: convttf.c
	$(call PRINTS,CC $(@F))
	$(SILENT)$(CC) $(CFLAGS) -lm -std=c99 -O2 -Wall -g $+ -o $@ \
		`freetype-config --libs` `freetype-config --cflags`

clean:
	@echo "Cleaning tools"
	$(SILENT)rm -f $(CLEANALL) $(shell for f in $(CLEANALL) ; do \
	    echo $$f.exe $$f.o $$f.obj ; done) *.ajf *~
	$(SILENT)$(MAKE) -C ucl clean
	$(SILENT)$(MAKE) -C rbspeex clean

=== rbutil/chinachippatcher/Makefile ===
#             __________               __   ___.
#   Open      \______   \ ____   ____ |  | _\_ |__   _______  ___
#   Source     |       _//  _ \_/ ___\|  |/ /| __ \ /  _ \  \/  /
#   Jukebox    |    |   (  <_> )  \___|    < | \_\ (  <_> > <  <
#   Firmware   |____|_  /\____/ \___  >__|_ \|___  /\____/__/\_ \
#                     \/            \/     \/    \/            \/
# $Id$
#
CFLAGS += -g -Wall

OUTPUT = chinachippatcher

LIBSOURCES = chinachip.c
SOURCES = $(LIBSOURCES) main.c

include ../libtools.make

=== rbutil/ipodpatcher/Makefile ===
#             __________               __   ___.
#   Open      \______   \ ____   ____ |  | _\_ |__   _______  ___
#   Source     |       _//  _ \_/ ___\|  |/ /| __ \ /  _ \  \/  /
#   Jukebox    |    |   (  <_> )  \___|    < | \_\ (  <_> > <  <
#   Firmware   |____|_  /\____/ \___  >__|_ \|___  /\____/__/\_ \
#                     \/            \/     \/    \/            \/
# $Id$
#

CFLAGS += -Wall -W

# Build with "make BOOTOBJS=1" to build with embedded bootloaders and the 
# --install option and interactive mode.  You need the full set of Rockbox 
# bootloaders in this directory - download them from
# http://download.rockbox.org/bootloader/ipod/bootloaders.zip

# Releases of ipodpatcher are created with "make RELEASE=1".  This
# enables BOOTOBJS and uses the VERSION string defined in main.c
ifdef RELEASE
CFLAGS += -DRELEASE
BOOTOBJS=1
endif

ifdef BOOTOBJS
BOOTSRC = ipod1g2g.c ipod3g.c ipod4g.c ipodcolor.c ipodmini1g.c \
	  ipodmini2g.c ipodnano1g.c ipodvideo.c ipodnano2g.c
CFLAGS += -DWITH_BOOTOBJS
endif

# additional frameworks to link on on OS X
LDOPTS_OSX = -framework CoreFoundation -framework IOKit

LIBSOURCES = ipodpatcher.c fat32format.c arc4.c \
	     ipodio-posix.c ipodio-win32-scsi.c ipodio-win32.c
SOURCES = main.c $(BOOTSRC) $(LIBSOURCES)
ipodpatcher: SOURCES+= ipodio-posix.c

OUTPUT = ipodpatcher
include ../libtools.make

ipodpatcher.exe: $(OBJDIR)ipodpatcher-rc.o
$(OBJDIR)ipodpatcher-rc.o: ipodpatcher.rc ipodpatcher.manifest
	@echo WINDRES $(notdir $<)
	$(SILENT)$(CROSS)$(WINDRES) -i $< -o $@

%.c: bootloader-%.ipod $(BIN2C)
	@echo BIN2C $<
	$(SILENT)$(BIN2C) -i $< $*

%.c: bootloader-%.ipodx $(BIN2C)
	@echo BIN2C $<
	$(SILENT)$(BIN2C) -i $< $*

=== rbutil/mkimxboot/Makefile ===
#             __________               __   ___.
#   Open      \______   \ ____   ____ |  | _\_ |__   _______  ___
#   Source     |       _//  _ \_/ ___\|  |/ /| __ \ /  _ \  \/  /
#   Jukebox    |    |   (  <_> )  \___|    < | \_\ (  <_> > <  <
#   Firmware   |____|_  /\____/ \___  >__|_ \|___  /\____/__/\_ \
#                     \/            \/     \/    \/            \/

# We use the SB code available in the Rockbox utils/sbtools directory
IMXTOOLS_DIR=../../utils/imxtools/sbtools/
CFLAGS += -I$(IMXTOOLS_DIR) -Wall
CFLAGS += -std=c99 -g -O3

OUTPUT = mkimxboot

# inputs for lib
IMXTOOLS_SOURCES = misc.c sb.c crypto.c crc.c aes128.c sha1.c elf.c
LIBSOURCES := dualboot.c mkimxboot.c md5.c \
	      $(addprefix $(IMXTOOLS_DIR),$(IMXTOOLS_SOURCES))
# inputs for binary only
SOURCES := $(LIBSOURCES) main.c
# dependencies for binary
EXTRADEPS :=

include ../libtools.make

# explicit dependencies on dualboot.{c,h} and mkimxboot.h
$(OBJDIR)mkimxboot.o: dualboot.h dualboot.c mkimxboot.c mkimxboot.h
$(OBJDIR)main.o: dualboot.h dualboot.c main.c mkimxboot.h

=== rbutil/mkmpioboot/Makefile ===
#             __________               __   ___.
#   Open      \______   \ ____   ____ |  | _\_ |__   _______  ___
#   Source     |       _//  _ \_/ ___\|  |/ /| __ \ /  _ \  \/  /
#   Jukebox    |    |   (  <_> )  \___|    < | \_\ (  <_> > <  <
#   Firmware   |____|_  /\____/ \___  >__|_ \|___  /\____/__/\_ \
#                     \/            \/     \/    \/            \/

TARGET_DIR ?= $(shell pwd)/
# We use the UCL code available in the Rockbox tools/ directory
CFLAGS += -I../../tools/ucl/include -Wall

OUTPUT = mkmpioboot

# inputs
LIBSOURCES = mkmpioboot.c
SOURCES = $(LIBSOURCES) main.c
EXTRADEPS = $(LIBUCL)

include ../libtools.make

# explicit dependencies
$(OBJDIR)mkmpioboot.o: mkmpioboot.c mkmpioboot.h

=== rbutil/mkrk27boot/Makefile ===
#             __________               __   ___.
#   Open      \______   \ ____   ____ |  | _\_ |__   _______  ___
#   Source     |       _//  _ \_/ ___\|  |/ /| __ \ /  _ \  \/  /
#   Jukebox    |    |   (  <_> )  \___|    < | \_\ (  <_> > <  <
#   Firmware   |____|_  /\____/ \___  >__|_ \|___  /\____/__/\_ \
#                     \/            \/     \/    \/            \/
# $Id$
#

FIRMWARE = ../../firmware/

DRIVERS = $(FIRMWARE)drivers/
EXPORT = $(FIRMWARE)export/

BUILDDATE=$(shell date -u +'-DYEAR=%Y -DMONTH=%m -DDAY=%d')
INCLUDE = -I$(EXPORT) -I$(FIRMWARE)include -I$(FIRMWARE)target/hosted -I$(FIRMWARE)target/hosted/sdl
DEFINES =  -DTEST_FAT -DDISK_WRITE -DHAVE_FAT16SUPPORT -D__PCTOOL__

CFLAGS = -Wall -g -std=gnu99 -Wno-pointer-sign $(DEFINES) -I. $(INCLUDE)
SIM_FLAGS = $(CFLAGS) $(BUILDDATE) -I$(FIRMWARE)/libc/include

OUTPUT = mkrk27boot

# inputs
LIBSOURCES := $(DRIVERS)fat.c $(FIRMWARE)libc/ctype.c  $(FIRMWARE)libc/strtok.c \
    $(FIRMWARE)libc/errno.c $(FIRMWARE)common/strlcpy.c $(FIRMWARE)common/unicode.c \
    $(FIRMWARE)common/file.c $(FIRMWARE)common/dir_uncached.c $(FIRMWARE)common/disk.c ata-sim.c mkrk27boot.c

SOURCES := $(LIBSOURCES) main.c

include ../libtools.make

SIMOBJS = $(addprefix $(OBJDIR),fat.o ctype.o strtok.o errno.o disk.o dir_uncached.o file.o unicode.o strlcpy.o)

$(SIMOBJS):
	@echo CC $<
	$(SILENT)mkdir -p $(dir $@)
	$(SILENT)$(CROSS)$(CC) $(SIM_FLAGS) -c -o $@ $<

=== rbutil/mktccboot/Makefile ===
#             __________               __   ___.
#   Open      \______   \ ____   ____ |  | _\_ |__   _______  ___
#   Source     |       _//  _ \_/ ___\|  |/ /| __ \ /  _ \  \/  /
#   Jukebox    |    |   (  <_> )  \___|    < | \_\ (  <_> > <  <
#   Firmware   |____|_  /\____/ \___  >__|_ \|___  /\____/__/\_ \
#                     \/            \/     \/    \/            \/
# $Id$
#

# We use the Telechips code available in the Rockbox tools/ directory
TOOLSDIR = ../../tools/
CFLAGS += -O -g -W -Wall -Wshadow -pedantic -I$(TOOLSDIR)

OUTPUT = mktccboot


# inputs
LIBSOURCES := mktccboot.c $(TOOLSDIR)telechips.c
SOURCES := $(LIBSOURCES) main.c
EXTRADEPS :=

include ../libtools.make

# rule for sources from tools dir
# Rules go _after_ including mkboot.make to have OBJDIR set up correctly.
# Paths are assumed to end with a /
telechips.o: $(OBJDIR)telechips.o

=== rbutil/mkzenboot/Makefile ===
#             __________               __   ___.
#   Open      \______   \ ____   ____ |  | _\_ |__   _______  ___
#   Source     |       _//  _ \_/ ___\|  |/ /| __ \ /  _ \  \/  /
#   Jukebox    |    |   (  <_> )  \___|    < | \_\ (  <_> > <  <
#   Firmware   |____|_  /\____/ \___  >__|_ \|___  /\____/__/\_ \
#                     \/            \/     \/    \/            \/

# We use the HMAC-SHA1 code from tools/
TOOLS_DIR=../../tools/
CFLAGS += -Wall -I$(TOOLS_DIR)
CFLAGS += -std=c99 -g
LDOPTS += -lz

OUTPUT = mkzenboot

# inputs for lib
TOOLS_SOURCES = hmac-sha1.c
LIBSOURCES := dualboot.c mkzenboot.c md5.c utils.c \
	      $(addprefix $(TOOLS_DIR),$(TOOLS_SOURCES))

# inputs for binary only
SOURCES := $(LIBSOURCES) main.c
# dependencies for binary
EXTRADEPS :=

include ../libtools.make

# explicit dependencies on dualboot.{c,h} and mkimxboot.h
$(OBJDIR)mkzenboot.o: dualboot.h dualboot.c mkzenboot.c mkzenboot.h
$(OBJDIR)main.o: dualboot.h dualboot.c main.c mkzenboot.h

=== rbutil/sansapatcher/Makefile ===
#             __________               __   ___.
#   Open      \______   \ ____   ____ |  | _\_ |__   _______  ___
#   Source     |       _//  _ \_/ ___\|  |/ /| __ \ /  _ \  \/  /
#   Jukebox    |    |   (  <_> )  \___|    < | \_\ (  <_> > <  <
#   Firmware   |____|_  /\____/ \___  >__|_ \|___  /\____/__/\_ \
#                     \/            \/     \/    \/            \/

TARGET_DIR ?= $(shell pwd)/
CFLAGS += -Wall -W -D_LARGEFILE64_SOURCE

OUTPUT = sansapatcher

# inputs
LIBSOURCES := sansapatcher.c sansaio-posix.c sansaio-win32.c
SOURCES := $(LIBSOURCES) main.c
# additional link dependencies for the standalone executable
EXTRADEPS :=

# Releases of sansapatcher are created with "make RELEASE=1".  This
# enables BOOTOBJS and uses the VERSION string defined in main.c
ifdef RELEASE
CFLAGS += -DRELEASE
BOOTOBJS=1
endif

ifdef WITH_BOOTOBJS
BOOTSRC = bootimg_c200.c bootimg_e200.c
SOURCES += $(BOOTSRC)
CFLAGS += -DWITH_BOOTOBJS
endif

include ../libtools.make

# find out if we need to link the manifest resource.
# Since libtools.make sets up BINARY we check it for the file extension .exe.
ifeq ($(findstring exe,$(BINARY)),exe)
$(BINARY): $(OBJDIR)sansapatcher-rc.o
endif

$(OBJDIR)main.o: $(BOOTSRC)
$(OBJDIR)sansapatcher-rc.o: sansapatcher.rc sansapatcher.manifest
	@echo WINDRES $(notdir $<)
	$(SILENT)$(CROSS)$(WINDRES) -i sansapatcher.rc -o $@

bootimg_c200.c: firmware.mi4 $(BIN2C)
	@echo BIN2C $<
	$(SILENT)$(BIN2C) $< $*

bootimg_e200.c: PP5022.mi4 $(BIN2C)
	@echo BIN2C $< $*
	$(SILENT)$(BIN2C) $< $*

=== rbutil/tools/Makefile ===

ifndef V
SILENT = @
endif

CFLAGS += -Wall -W -D_LARGEFILE64_SOURCE

ifeq ($(findstring CYGWIN,$(shell uname)),CYGWIN)
CROSS=
CFLAGS+=-mno-cygwin
else
ifeq ($(findstring MINGW,$(shell uname)),MINGW)
CROSS=
else
CROSS=i586-mingw32msvc-
endif
endif

NATIVECC = gcc
CC = $(CROSS)gcc
WINDRES = $(CROSS)windres


all: bin2c

bin2c: bin2c.c
	@echo CC $<
	$(SILENT)$(NATIVECC) $(CFLAGS) -o bin2c bin2c.c

clean:
	$(RM) bin2c bin2c.exe

=== tools/rbspeex/Makefile ===
#             __________               __   ___.
#   Open      \______   \ ____   ____ |  | _\_ |__   _______  ___
#   Source     |       _//  _ \_/ ___\|  |/ /| __ \ /  _ \  \/  /
#   Jukebox    |    |   (  <_> )  \___|    < | \_\ (  <_> > <  <
#   Firmware   |____|_  /\____/ \___  >__|_ \|___  /\____/__/\_ \
#                     \/            \/     \/    \/            \/
# $Id$
#

ifndef V
SILENT = @
endif

ifeq ($(OS),Windows_NT)
mkdir = if not exist $(subst /,\,$(1)) mkdir $(subst /,\,$(1))
else
mkdir = mkdir -p $(1)
endif

SPEEXSRC = ../../lib/rbcodec/codecs/libspeex

INCLUDES = -I $(SPEEXSRC)
SPEEXOPTS = -DHAVE_CONFIG_H -DROCKBOX_VOICE_ENCODER

CFLAGS += $(SPEEXOPTS) $(INCLUDES) -O3 -fomit-frame-pointer -Wno-unused-parameter

CPPDEFINES := $(shell echo foo | $(CROSS)$(CC) -dM -E -)
#build standalone win32 executables on cygwin
ifeq ($(findstring CYGWIN,$(CPPDEFINES)),CYGWIN)
CFLAGS+=-mno-cygwin
COMPILETARGET = cygwin
else
ifeq ($(findstring MINGW,$(CPPDEFINES)),MINGW)
COMPILETARGET = mingw
else
# OS X specifics. Needs to consider cross compiling for Windows.
ifeq ($(findstring APPLE,$(CPPDEFINES)),APPLE)
# when building libs for OS X build for both i386 and ppc at the same time.
# This creates fat objects, and ar can only create the archive but not operate
# on it. As a result the ar call must NOT use the u (update) flag.
ARCHFLAGS = -arch ppc -arch i386
# building against SDK 10.4 is not compatible with gcc-4.2 (default on newer Xcode)
# might need adjustment for older Xcode.
CC ?= gcc-4.0
CFLAGS += -isysroot /Developer/SDKs/MacOSX10.4u.sdk -mmacosx-version-min=10.4
NATIVECC ?= gcc-4.0
COMPILETARGET = darwin
else
COMPILETARGET = posix
endif
endif
endif
$(info Compiler creates $(COMPILETARGET) binaries)

# don't try to use the systems libspeex when building a static binary.
ifndef STATIC
SYS_SPEEX ?= $(shell pkg-config --silence-errors --libs speex speexdsp)
endif

# fall back to our own librbspeex if no suitable found.
ifeq ($(SYS_SPEEX),)
# This sets up 'SRC' based on the files mentioned in SOURCES
SRC := $(shell $(CC) $(CFLAGS) -E -P -xc $(SPEEXSRC)/SOURCES)
LIBS = $(TARGET_DIR)librbspeex.a
else
LIBS = $(SYS_SPEEX)
endif

TARGET_DIR ?= $(shell pwd)/
BUILD_DIR ?= $(TARGET_DIR)build$(COMPILETARGET)
SOURCES = $(SRC:%.c=$(SPEEXSRC)/%.c) rbspeex.c rbspeexenc.c rbspeexdec.c
OBJS = $(addprefix $(BUILD_DIR)/,$(SRC:%.c=%.o))
DIRS = 

.PHONY : all

all: ../rbspeexenc ../rbspeexdec

$(foreach src,$(SOURCES),$(eval $(BUILD_DIR)/$(subst .c,.o,$(notdir $(src))): $(src)))
$(foreach src,$(SOURCES),$(eval $(BUILD_DIR)/$(subst .c,.d,$(notdir $(src))): $(src)))
DEPS = $(addprefix $(BUILD_DIR)/,$(subst .c,.d,$(notdir $(SOURCES))))
-include $(DEPS)

%.d:
	$(SILENT)$(call mkdir,$(BUILD_DIR))
	$(SILENT)$(CC) -MG -MM -MT $(subst .d,.o,$@) $(CFLAGS) -o $(BUILD_DIR)/$(notdir $@) $<

dll: $(TARGET_DIR)rbspeex.dll
	
$(TARGET_DIR)rbspeex.dll: $(OBJS) $(BUILD_DIR)/rbspeex.o
	@echo DLL $(notdir $@)
	$(SILENT)$(CROSS)$(CC) $(CFLAGS) -shared -o $@ $^ \
		    -Wl,--output-def,$(TARGET_DIR)rbspeex.def

$(TARGET_DIR)librbspeex.a: $(OBJS) $(BUILD_DIR)/rbspeex.o
	@echo AR $(notdir $@)
	$(SILENT)$(CROSS)$(AR) rcs $@ $^

librbspeex.a: $(TARGET_DIR)librbspeex.a
	
../rbspeexenc: $(OBJS) $(BUILD_DIR)/rbspeexenc.o librbspeex.a
	@echo Linking ../rbspeexenc
	$(SILENT)$(CROSS)$(CC) $(CFLAGS) $(ARCHFLAGS) -o ../rbspeexenc $(BUILD_DIR)/rbspeexenc.o \
		    $(LIBS) -lm $(TARGET_DIR)librbspeex.a

../rbspeexdec: $(OBJS) librbspeex.a $(BUILD_DIR)/rbspeexdec.o
	@echo Linking ../rbspeexdec
	$(SILENT)$(CROSS)$(CC) $(CFLAGS) $(ARCHFLAGS) -o ../rbspeexdec $(BUILD_DIR)/rbspeexdec.o \
		    $(LIBS) -lm $(TARGET_DIR)librbspeex.a

%.o:
	@echo CC $<
	$(SILENT)$(CROSS)$(CC) $(CFLAGS) $(ARCHFLAGS) -c $< -o $@

clean:
	rm -f $(OBJS) $(TARGET_DIR)librbspeex* ../rbspeexenc ../rbspeexdec
	rm -f $(DEPS)
	rm -rf build*

$(BUILD_DIR):
	@echo MKDIR $(BUILD_DIR)
	$(SILENT)$(call mkdir, $(BUILD_DIR))

=== rbutil/mkimxboot/dualboot/Makefile ===
CC=gcc
LD=ld
OC=objcopy
CROSS_PREFIX=arm-elf-eabi-
REGS_PATH=../../../firmware/target/arm/imx233/regs
CFLAGS=-mcpu=arm926ej-s -std=gnu99 -I. -I$(REGS_PATH) -nostdlib -ffreestanding -fomit-frame-pointer -O
# Edit the following variables when adding a new target.
# mkimxboot.c also needs to be edited to refer to these
# To add a new target x you need to:
# 1) add x to the list in TARGETS
# 2) create a variable named OPT_x of the form:
#    OPT_x=target specific defines
TARGETS=fuzeplus zenxfi2 zenxfi3 nwze370 nwze360
OPT_fuzeplus=-DSANSA_FUZEPLUS -DIMX233_SUBTARGET=3780
OPT_zenxfi2=-DCREATIVE_ZENXFI2 -DIMX233_SUBTARGET=3780
OPT_zenxfi3=-DCREATIVE_ZENXFI3 -DIMX233_SUBTARGET=3780
OPT_nwze370=-DSONY_NWZE370 -DIMX233_SUBTARGET=3780
OPT_nwze360=-DSONY_NWZE360 -DIMX233_SUBTARGET=3780

BOOTOBJS=$(patsubst %, dualboot_%.o, $(TARGETS))
BOOTBINS=$(patsubst %, dualboot_%.arm-bin, $(TARGETS))
BOOTELFS=$(patsubst %, dualboot_%.arm-elf, $(TARGETS))

all: ../dualboot.h ../dualboot.c $(BOOTELFS)

# Dualboot bootloaders

dualboot_%.o: dualboot.c
	$(CROSS_PREFIX)$(CC) $(CFLAGS) $(OPT_$(@:dualboot_%.o=%)) -c -o $@ $^

dualboot_%.arm-elf: dualboot_%.o
	$(CROSS_PREFIX)$(LD) $(LDFLAGS) -Tdualboot.lds -o $@ $<

# Rules for the ARM code embedded in mkamsboot - assemble, link, then extract
# the binary code and finally convert to .h for building in mkamsboot

%.arm-bin: %.arm-elf
	$(CROSS_PREFIX)$(OC) -O binary $< $@

../dualboot.c ../dualboot.h: $(BOOTBINS) bin2c
	./bin2c ../dualboot $(BOOTBINS)

bin2c: bin2c.c
	$(CC) -o bin2c bin2c.c

clean:
	rm -f *~ bin2c $(BOOTBINS) $(BOOTOBJS) $(BOOTELFS)

=== debian/changelog ===
rockboxutility (1.4.0-0mx150+1) mx; urgency=medium

  * New upstream release.

 -- Steven Pusser (Stevo) <maintainer@mepiscommunity.org>  Mon, 16 May 2016 13:02:18 -0700

rockboxutility (1.3.1-0mcr120+1) mepis; urgency=low

  * Rebuild for MEPIS 12.0 community repository.
  * debian/rules:
    - compress deb packages with xz.
    - switch to tiny debhelper rules file, remove cdbs as build-depend.
  * debian/control: change section to sound.

 -- Steven Pusser (Stevo) <maintainer@mepiscommunity.org>  Sun, 29 Sep 2013 15:44:12 -0700

rockboxutility (1.2.6-0mlrepo1) mepis; urgency=low

  * Initial build for MEPIS 8.0

 -- Timothy E. Harris <maintainer@mepiscommunity.org>  Sat, 8 May 2010 16:38:41 -0400

=== debian/control ===
Source: rockboxutility
Section: utils
Priority: optional
Maintainer: Steven Pusser (Stevo) <maintainer@mepiscommunity.org>
Bugs: mailto: maintainer@mepiscommunity.org
XSBC-Original-Maintainer: Timothy E. Harris <maintainer@mepiscommunity.org>
Build-Depends: debhelper (>= 9),
               libqt4-dev,
               libusb-1.0-0-dev | libusb-dev,
               zlib1g-dev
Standards-Version: 3.9.6
Homepage: http://www.rockbox.org/wiki/RockboxUtility

Package: rockboxutility
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: festival | espeak | flite
Description: Rockbox firmware installation utility.
 .
 RockboxUtility is an easy to use Qt-based firmware installer for Rockbox.
 Rockbox is an open source firmware for mp3 players, adding extra file type
 support, games and themes.
 .
 Rockbox runs well on these players, has a complete manual, and is supported by
 the installer: 
 .
  Apple: iPod 1g through 5.5g, iPod Mini, iPod Nano 1g.
  Archos: Jukebox 5000, 6000, Studio, Recorder, FM Recorder, Recorder V2 
  and Ondio.
  Cowon: Audio X5, X5V, X5L, M5, M5L, M3 and M3L.
  iriver: iHP100 series, H100 series, H300 series and H10 series 
  Olympus: M:Robe 100 
  Packard Bell: Vibe 500  
  SanDisk: Sansa c200, e200 and e200R series, Fuze, Clip, Clip+ and Clip Zip 
  Toshiba: Gigabeat X and F series
 .
 Unstable ports
 .
 Rockbox runs on these players, but is incomplete, less usable or has problems
 that limit it to advanced users:
 .
    Apple: iPod Nano 2g
    Cowon: D2
    HiFi E.T: MA9
    HiFiMAN: HM-601, HM-602, HM-603, HM-801
    MPIO: HD200
    Olympus: M:Robe 500, M:robe 100
    Philips: GoGear SA9200, GoGear HDD16x0 and HDD63x0
    Samsung: YP-R0, YH-820, YH-920 and YH-925
    SanDisk: Sansa Fuze+
    Toshiba: Gigabeat S 
 
Package: rockboxutility-dbg
Architecture: any
Section: debug
Priority: extra
Depends: ${misc:Depends},
         rockboxutility (= ${binary:Version})
Description: Rockbox installation utility (debug package)
 This package contains the Rockbox installation utility debugging symbols.

=== debian/rules ===
#!/usr/bin/make -f
export DH_OPTIONS := -O--sourcedirectory=rbutil
%:
	dh $@ --parallel

override_dh_clean:
	dh_clean
	rm -rf rbutil/rbutilqt/build rbutil/rbutilqt/lang/*.qm
	$(MAKE) -C rbutil/mkamsboot clean

override_dh_strip:
	dh_strip --dbg-package=rockboxutility-dbg

override_dh_builddeb:
	dh_builddeb -- -Z xz

=== debian/watch ===
version=3
http://download.rockbox.org/rbutil/source/RockboxUtility-v([\d\.]+)-src\.tar\.(?:bz2|xz|gz)
